package cn.ibizlab.businesscentral.core.odoo_product.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.businesscentral.core.odoo_product.domain.Product_taxes_rel;
import cn.ibizlab.businesscentral.core.odoo_product.filter.Product_taxes_relSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface Product_taxes_relMapper extends BaseMapper<Product_taxes_rel>{

    Page<Product_taxes_rel> searchDefault(IPage page, @Param("srf") Product_taxes_relSearchContext context, @Param("ew") Wrapper<Product_taxes_rel> wrapper) ;
    @Override
    Product_taxes_rel selectById(Serializable id);
    @Override
    int insert(Product_taxes_rel entity);
    @Override
    int updateById(@Param(Constants.ENTITY) Product_taxes_rel entity);
    @Override
    int update(@Param(Constants.ENTITY) Product_taxes_rel entity, @Param("ew") Wrapper<Product_taxes_rel> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<Product_taxes_rel> selectByTaxId(@Param("id") Serializable id) ;

    List<Product_taxes_rel> selectByProdId(@Param("id") Serializable id) ;


}
